odl_module widgets {

   param new_name ""
   param delete_name delete
   param member_name mem
   param init_name init
   param exit_name exit

   class kwidget {} {
      attr topframe ""
      method "" get_top {}
   }

   class ktext { kwidget } {
      attr want_x 1
      attr want_y 1

      method "" edit_style { {style vi} }
      method "" get_text {}
      method "" get_x {}
      method "" get_y {}
   }

   class kanvas { kwidget } {
      attr want_x 1
      attr want_y 1

      method "" get_canvas {}
      method "" get_x {}
      method "" get_y {}

      # items = list of names of tcl_obj items to be dragged.
      # ghost = non-0 if 'items' are ghosts.
      method "" startdrag {x y items {ghost 0}}
      method "" dragto {x y}
      method "" stopdrag {}

      # Private
      attr dragging [list]
      attr drag_startx -1
      attr drag_starty -1
      attr drag_x -1
      attr drag_y -1
      attr drag_ghost 0
   }
}
