
# Testing multiple inheritance

odl_module mult {

   param new_name cnew
   param delete_name "-"
   param member_name "-"

   class base1 {} {
      attr dog 0
      attr cat 0
      method "" overloaded {x}
   }

   class base2 {} {
      attr location "here"
      attr color blue
      contains base1 sub_obj1
      method "" overloaded {x}
   }

   class derived {base1 base2} {
      attr owner "me"
      contains base2 sub_obj2
      # The 'overloaded' method is inherited from 'base1'.
      # The one in 'base2' is ignored.  Leftmost base classes
      # get priority.  There is no name clash as in C++
      # (which may or may not be a good thing).
   }
}

